'use strict';
const stripe = require('stripe')('sk_test_51KrKJCCIpwfpeAswFmke8ZEqwz4QW4Y2eHub6vmWFe6ta9hbMuVOdkjdh9wh1QcOlILjw25zUhOPxQBn745m12eu00Z0CDtjvp');

/**
 * Read the documentation (https://strapi.io/documentation/3.0.0-beta.x/concepts/controllers.html#core-controllers)
 * to customize this controller
 */

module.exports = {
  create: async ctx => {
    const {
      address,
      amount,
      product,
      token,

    } = ctx.request.body;

    // Charge the customer
    try {    

	  	 // stripe charge
	  	 
		 await stripe.customers
		  .create({
		    email: ctx.state.user.email,
		    source: token
		  })
		  .then((customer) => {
		    return stripe.charges.create({
		        // Transform cents to dollars.
		        amount: amount * 100,
		        currency: 'usd',
		        description: `Order ${new Date()} by ${ctx.state.user.id}`,
		        customer: customer.id
		
		      });
		  });
	
      

      // Register the order in the database
      try {
        const orders = await strapi.services.order.create({
          user: ctx.state.user.id,
          address,
          amount,
          product,
        });
        
        
        //email
        
         if (orders.id){
	      
	      await strapi.plugins['email'].services.email.send({
	        to: ctx.state.user.email,
	        subject: 'Thank you for your purchase',
	        text: `
	       
	       		 USD${orders.amount} is charged from your credit card on Stripe.
	          
	        `,
	      });
	      
	      
      	 }
        

        return orders;
      } catch (err) {
        console.log(err)
      }
      

      
      
      
      
    } catch (err) {
      	console.log(err)
    }
  },
};

